bots/urls.py
from django.urls import path

from bots import views
from bots.views import BotView

app_name = 'bots'
urlpatterns = [
    path('', BotView.as_view(), name='bot-list'),
    path('tick/', views.execute_tick, name='tick'),
    path('init-bot/', views.init, name='init'),
    path('activate/<int:bot_id>/', views.activate, name='activate'),
    path('return-cs/<int:bot_id>/', views.return_cs, name='return_cs'),
    path('retire/<int:bot_id>/', views.retire, name='retire'),
]

bots/models.py
from django.db import models


class Army(models.Model):
    label = models.CharField(max_length=64)

    color = models.CharField(max_length=2)

    def __str__(self):
        return '[%s | %d]' % (self.label, self.id)


class ArmyUnit(models.Model):
    army = models.ForeignKey(
        Army,
        on_delete=models.CASCADE,
    )

    ma_unit_id = models.PositiveIntegerField()

    count_percent = models.FloatField(
        null=True,
        blank=True,
    )

    count_absolute = models.PositiveIntegerField(
        null=True,
        blank=True,
    )

    experience = models.FloatField()


class CombatSpellSettings(models.Model):
    army = models.ForeignKey(
        Army,
        on_delete=models.CASCADE,
    )

    tier = models.PositiveSmallIntegerField()

    ma_spell_1_id = models.PositiveIntegerField(
        blank=True,
        null=True,
    )

    ma_spell_2_id = models.PositiveIntegerField(
        blank=True,
        null=True,
    )

    ma_spell_3_id = models.PositiveIntegerField(
        blank=True,
        null=True,
    )

    ma_spell_4_id = models.PositiveIntegerField(
        blank=True,
        null=True,
    )

    def __str__(self):
        return '[tier %d | %d-%d-%d-%d | %d]' % (self.tier, self.ma_spell_1_id, self.ma_spell_2_id, self.ma_spell_3_id,
                                                 self.ma_spell_4_id, self.id)


class Bot(models.Model):
    name = models.CharField(max_length=255)
    province = models.CharField(max_length=255)
    created = models.DateTimeField(
        auto_now_add=True,
    )
    updated = models.DateTimeField(
        auto_now=True,
    )

    color = models.CharField(max_length=2)

    army = models.ForeignKey(
        Army,
        null=True,
        blank=True,
        on_delete=models.CASCADE,
    )
    combat_spell_settings = models.ForeignKey(
        CombatSpellSettings,
        null=True,
        blank=True,
        on_delete=models.CASCADE,
    )
    army_power = models.PositiveIntegerField(
        null=True,
        blank=True,
    )

    active = models.BooleanField()
    expires_returns_at = models.DateTimeField(
        null=True,
        blank=True
    )

    return_cs_safety_flag = models.PositiveIntegerField(
        default=0,
        help_text="Last CS time, used to make sure in case of cyclic error, each CS is tried just once.",
    )

    ma_province_id = models.PositiveIntegerField()
    ma_login = models.CharField(max_length=20)
    ma_password = models.CharField(max_length=20)

    def __str__(self):
        return '[%s | %s | %d]' % (self.name, self.province, self.id)


class UsersLogin(models.Model):
    undown = models.CharField(unique=True, max_length=20)
    heslo = models.CharField(max_length=20)
    ip = models.CharField(max_length=15)
    code = models.CharField(max_length=32)
    code2 = models.CharField(max_length=32)
    kontrola_ip = models.PositiveIntegerField()
    kontrola_cook = models.PositiveIntegerField()
    sledovat = models.PositiveIntegerField()
    browser = models.CharField(max_length=255)
    email = models.CharField(max_length=80)
    send_hlidka = models.IntegerField()
    hlidka_mail = models.CharField(max_length=80)
    reserved_spravce = models.CharField(max_length=50)
    reserved_provi = models.CharField(max_length=50)
    ver_text = models.CharField(max_length=8)
    verified = models.IntegerField()

    class Meta:
        managed = False
        db_table = 'users_login'


class Users(models.Model):
    spravce = models.CharField(unique=True, max_length=255)
    provincie = models.CharField(unique=True, max_length=255)
    email = models.CharField(max_length=50, blank=True, null=True)
    pohlavi = models.CharField(max_length=1)
    slava = models.SmallIntegerField(default=0)
    slava_max = models.SmallIntegerField(default=0)
    titul = models.CharField(max_length=64)
    id_povolani = models.PositiveIntegerField()
    barva = models.CharField(max_length=1)
    presvedceni = models.CharField(max_length=1)
    puvodni_presvedceni = models.CharField(max_length=1)
    specializace = models.CharField(max_length=2)
    id_rasa = models.PositiveIntegerField()
    caszalozeni = models.DateTimeField()
    last_visit = models.DateField(auto_now_add=True)
    time_posl_tu = models.PositiveIntegerField(default=0)
    zbyva_tu = models.SmallIntegerField()
    power = models.PositiveIntegerField(default=0)
    zlato = models.IntegerField(default=0)
    mana = models.IntegerField(default=0)
    mana_max = models.IntegerField(default=0)
    lide = models.IntegerField()
    plocha = models.PositiveIntegerField()
    zbyva_plocha = models.PositiveIntegerField(default=0)
    odehrano_tahu = models.PositiveIntegerField()
    brana = models.CharField(max_length=32)
    brana_no = models.PositiveIntegerField(default=0)
    max_brana_no = models.IntegerField()
    dane = models.PositiveSmallIntegerField()
    protekce = models.PositiveSmallIntegerField()
    protekce_od_casu = models.IntegerField()
    posledni_utok = models.DateTimeField()
    protekce_ma = models.PositiveSmallIntegerField()
    sk = models.PositiveSmallIntegerField(default=0)
    id_aliance = models.IntegerField(default=0)
    account_id = models.IntegerField(default=0)
    verified = models.IntegerField()
    is_bot = models.IntegerField(default=0)

    class Meta:
        managed = False
        db_table = 'users'


class NocniKlid(models.Model):
    id_user = models.IntegerField(primary_key=True)
    start_time = models.TimeField(default='00:00:00')
    end_time = models.TimeField(default='00:00:00')
    next_change = models.DateTimeField(auto_now_add=True)
    posilat_hlidku_v_noci = models.IntegerField(default=0)

    class Meta:
        managed = False
        db_table = 'nocni_klid'


class UspesnostSouboju(models.Model):
    id_user = models.PositiveIntegerField(primary_key=True)

    class Meta:
        managed = False
        db_table = 'uspesnost_souboju'


class Bdv(models.Model):
    id_user = models.PositiveIntegerField()
    pocet = models.PositiveIntegerField()
    id_bdv = models.PositiveSmallIntegerField()

    class Meta:
        managed = False
        db_table = 'bdv'
        unique_together = (('id_user', 'id_bdv'),)


class Aliance(models.Model):
    id_aliance = models.IntegerField(primary_key=True)
    presvedceni = models.CharField(max_length=1)
    nazev_aliance = models.CharField(max_length=150)
    popis_aliance = models.CharField(max_length=255)
    vudce = models.PositiveIntegerField()
    zastupce = models.IntegerField(default=0)
    clenove = models.TextField()
    cekajici = models.TextField(default='')
    body = models.IntegerField(default=0)
    is_bot_alliance = models.IntegerField(default=0)

    class Meta:
        managed = False
        db_table = 'aliance'


class Ally(models.Model):
    id_user = models.PositiveIntegerField()
    id_aliance = models.IntegerField()

    class Meta:
        managed = False
        db_table = 'ally'
        unique_together = (('id_user', 'id_aliance'),)


class MaUsersSetup(models.Model):
    user_id = models.PositiveIntegerField(primary_key=True)

    class Meta:
        managed = False
        db_table = 'ma_users_setup'


class MaUsersSpecials(models.Model):
    id_user = models.IntegerField()

    class Meta:
        managed = False
        db_table = 'ma_users_specials'


class MaUsersSetupMenus(models.Model):
    user_id = models.PositiveIntegerField()
    item_id = models.PositiveIntegerField()
    menu_set = models.PositiveIntegerField()
    item_order = models.PositiveIntegerField()

    class Meta:
        managed = False
        db_table = 'ma_users_setup_menus'
        unique_together = (('user_id', 'item_id'),)


class Jedn(models.Model):
    id_user = models.PositiveIntegerField()
    id_jednotky = models.PositiveSmallIntegerField()
    pocet_jedn = models.PositiveIntegerField()
    zkusenost = models.FloatField()

    class Meta:
        managed = False
        db_table = 'jedn'
        unique_together = (('id_user', 'id_jednotky'),)


class Jednotky(models.Model):
    id = models.PositiveSmallIntegerField(primary_key=True)
    power = models.FloatField()

    class Meta:
        managed = False
        db_table = 'jednotky'


class Kouzla(models.Model):
    id = models.PositiveSmallIntegerField(primary_key=True)
    nazev = models.CharField(max_length=150)
    barva = models.CharField(max_length=1)
    special = models.CharField(max_length=1)
    druh = models.CharField(max_length=3)
    mana_sesl = models.PositiveIntegerField()
    sesl_tu = models.PositiveSmallIntegerField()
    sesl_tu_posl = models.PositiveIntegerField()
    trvani_tu = models.PositiveSmallIntegerField()
    ucinek = models.TextField()
    popis = models.CharField(max_length=255)
    text_pri_seslani = models.CharField(max_length=255)
    cena_zl = models.PositiveIntegerField()
    cena_mn = models.PositiveIntegerField()
    vynalezani_tu = models.PositiveIntegerField()
    brana = models.PositiveIntegerField()
    skm = models.PositiveIntegerField(db_column='SKM')  # Field name made lowercase.
    skb = models.PositiveIntegerField(db_column='SKB')  # Field name made lowercase.

    class Meta:
        managed = False
        db_table = 'kouzla'


class Kzl(models.Model):
    id_kzl = models.PositiveSmallIntegerField()
    id_user = models.PositiveIntegerField()
    ucinek = models.FloatField()

    class Meta:
        managed = False
        db_table = 'kzl'
        unique_together = (('id_user', 'id_kzl'),)


class Obrana(models.Model):
    id_user = models.PositiveIntegerField(primary_key=True)
    id_kzl_1 = models.SmallIntegerField(default=0)
    id_kzl_2 = models.SmallIntegerField(default=0)
    id_kzl_3 = models.SmallIntegerField(default=0)
    id_kzl_4 = models.SmallIntegerField(default=0)

    class Meta:
        managed = False
        db_table = 'obrana'


class Rezisty(models.Model):
    id_user = models.PositiveIntegerField()

bots/views.py
from django.shortcuts import redirect, get_object_or_404, render
from django.views.decorators.http import require_POST
from django.views.generic import ListView

from bots.core import initialize_bot, activate_bot, retire_bot, return_possible_cs
from bots.models import Bot
from bots.tick import tick


class BotView(ListView):
    model = Bot
    queryset = Bot.objects.select_related('army')


@require_POST
def execute_tick(request):
    tick()

    return redirect('bots:bot-list')


@require_POST
def init(request):
    initialize_bot()

    return redirect('bots:bot-list')


@require_POST
def activate(request, bot_id: int):
    bot = get_object_or_404(Bot, id=bot_id)
    activate_bot(bot)

    return redirect('bots:bot-list')


@require_POST
def return_cs(request, bot_id: int):
    bot = get_object_or_404(Bot, id=bot_id)
    return_possible_cs(bot)

    return render(request, 'bots/bot_list.html', {'object_list': Bot.objects.select_related('army').all()})


@require_POST
def retire(request, bot_id: int):
    bot = get_object_or_404(Bot, id=bot_id)
    retire_bot(bot)

    return redirect('bots:bot-list')

bots/templates/bots/bot_list.html
{% extends 'bots/layout.html' %}
{% load humanize %}

{% block title %}Home{% endblock %}

{% block content %}
    <h1><code>Hell0 there, fell0w h00man!</code></h1>

    <div class="form-row">
        <div class="col">
            <form action="{% url 'bots:tick' %}" method="post">
                {% csrf_token %}
                <button type="submit" class="btn btn-primary">TICK</button>
            </form>

        </div>
        <div class="col">
            <form action="{% url 'bots:init' %}" method="post">
                {% csrf_token %}
                <button type="submit" class="btn btn-secondary">Initialize new bot</button>
            </form>

        </div>
    </div>

    <table class="table table-sm my-4">
        <thead>
        <tr>
            <th scope="col">#</th>
            <th scope="col">Name</th>
            <th scope="col">Regent</th>
            <th scope="col">Active</th>
            <th scope="col">Color</th>
            <th scope="col">MA ID</th>
            <th scope="col">Login</th>
            <th scope="col">Password</th>
            <th scope="col">Army</th>
            <th scope="col">Army power</th>
            <th scope="col">Returns / expires</th>
            <th scope="col" colspan="3">Actions</th>
        </tr>
        </thead>
        <tbody>
        {% for bot in object_list %}
            <tr>
                <th scope="row">{{ bot.id }}</th>
                <td>{{ bot.name }}</td>
                <td>{{ bot.province }}</td>
                <td>
                    {% if bot.active %}
                        <span class="badge badge-success">Yes</span>
                    {% else %}
                        <span class="badge badge-light">No</span>
                    {% endif %}
                </td>
                <td><code>{{ bot.color }}</code></td>
                <td>{{ bot.ma_province_id }}</td>
                <td><code>{{ bot.ma_login }}</code></td>
                <td><code>{{ bot.ma_password }}</code></td>
                <td>{{ bot.army.label }} [{{ bot.army.id }}]</td>
                <td>{{ bot.army_power|intcomma }}</td>
                <td title="{{ bot.expires_returns_at }}">{{ bot.expires_returns_at|naturaltime }}</td>
                <td>
                    <form action="{% url 'bots:activate' bot_id=bot.id %}" method="post">
                        {% csrf_token %}
                        <button type="submit" class="btn btn-sm btn-primary"{% if bot.active %} disabled{% endif %}>activate</button>
                    </form>
                </td>
                <td>
                    <form action="{% url 'bots:return_cs' bot_id=bot.id %}" method="post">
                        {% csrf_token %}
                        <button type="submit" class="btn btn-sm btn-secondary"{% if not bot.active %} disabled{% endif %}>return CS</button>
                    </form>
                </td>
                <td>
                    <form action="{% url 'bots:retire' bot_id=bot.id %}" method="post">
                        {% csrf_token %}
                        <button type="submit" class="btn btn-sm btn-warning"{% if not bot.active %} disabled{% endif %}>retire</button>
                    </form>
                </td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

bots/templates/bots/index.html
{% extends 'bots/layout.html' %}

{% block title %}Home{% endblock %}

{% block content %}
    <h1>Hello there, fellow hooman!</h1>
{% endblock %}

bots/templates/bots/layout.html
{% load static %}<!doctype html>
<html lang="en">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="//stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
          crossorigin="anonymous">

    <link rel="apple-touch-icon" sizes="57x57" href="{% static 'apple-icon-57x57.png' %}">
    <link rel="apple-touch-icon" sizes="60x60" href="{% static 'apple-icon-60x60.png' %}">
    <link rel="apple-touch-icon" sizes="72x72" href="{% static 'apple-icon-72x72.png' %}">
    <link rel="apple-touch-icon" sizes="76x76" href="{% static 'apple-icon-76x76.png' %}">
    <link rel="apple-touch-icon" sizes="114x114" href="{% static 'apple-icon-114x114.png' %}">
    <link rel="apple-touch-icon" sizes="120x120" href="{% static 'apple-icon-120x120.png' %}">
    <link rel="apple-touch-icon" sizes="144x144" href="{% static 'apple-icon-144x144.png' %}">
    <link rel="apple-touch-icon" sizes="152x152" href="{% static 'apple-icon-152x152.png' %}">
    <link rel="apple-touch-icon" sizes="180x180" href="{% static 'apple-icon-180x180.png' %}">
    <link rel="icon" type="image/png" sizes="192x192" href="{% static 'android-icon-192x192.png' %}">
    <link rel="icon" type="image/png" sizes="32x32" href="{% static 'favicon-32x32.png' %}">
    <link rel="icon" type="image/png" sizes="96x96" href="{% static 'favicon-96x96.png' %}">
    <link rel="icon" type="image/png" sizes="16x16" href="{% static 'favicon-16x16.png' %}">
    <link rel="shortcut icon" type="image/x-icon" href="{% static '/favicon.ico' %}">
    <link rel="icon" type="image/x-icon" href="{% static '/favicon.ico' %}">
    <meta name="msapplication-TileImage" content="{% static 'ms-icon-144x144.png' %}">

    <title>MA BOTS | {% block title %}{% endblock %}</title>
</head>
<body>

<div class="container-fluid">
    {% block content %}{% endblock %}
</div>

<!-- Optional JavaScript -->
<!-- jQuery first, then Popper.js, then Bootstrap JS -->
<script src="//code.jquery.com/jquery-3.5.1.min.js" crossorigin="anonymous"></script>
<script src="//cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" crossorigin="anonymous"></script>
<script src="//stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" crossorigin="anonymous"></script>
{% block js %}{% endblock %}
</body>
</html>